// General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
// base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
// The model can simulate OLEDs, Perovskite cells, and OFETs.
// 
// Copyright (C) 2008-2020 Roderick C. I. MacKenzie
// All rights reserved.
// 
// https://www.gpvdm.com
// r.c.i.mackenzie at googlemail.com
// 
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.
//     * Neither the name of the GPVDM nor the
//       names of its contributors may be used to endorse or promote products
//       derived from this software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
// DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sim.h"
#include <math.h>

void dirty_fit(struct device *in)
{
/*FILE *out;
out=fopen("./fit.dat","w");
double n=1e21;
double mu_min=0.0;
double Rbi_mul;
double langevin;
double Tlc=300.0;
double mue0=0.65e-25;
double epc=3.8*epsilon0;
do
{
	mu_min=(mue0)*pow(n,0.8);
	langevin=q*(mu_min)/(epc);
	double deltaE=in->deltaE[0];
	//printf("%e\n",langevin);
//	double rc=q*q/(4.0*pi*epsilon0*3.8*kb*Tlc);
//	double p=q*in->A[0];
//	//printf("%e %e\n",deltaE,A);
//	double R=in->a[0];
//	double Dp=(kb*Tlc*mu_min/q/p)*exp((deltaE*q/(kb*Tlc)));
//	Rbi_mul=1.0/(1-exp(-rc/R)+(Dp*rc/R/R)*exp(-rc/R));

	Rbi_mul=exp(deltaE*q/(kb*Tlc));
	fprintf(out,"%e %e %e\n",n,langevin*Rbi_mul,mu_min);

n*=1.1;
}
while (n<2e23);
fclose(out);
exit(0);*/
}

void rbi_test(struct device *in)
{
/*	FILE *file_rbi;
	file_rbi=fopena(in->outputpath,"./rbi.dat","w");
	double den=1e21;
	double offset=0.0;
	double alpha_mue=0.0;
	double beta_muh=0.0;

	do
	{
	offset=get_top_from_n(den,300.0,0.1,1e27,1,dos_all);
	alpha_mue=in->alpha*get_n_mu(offset,300.0,0.1,1,in->adv_sim)/2.0;

	offset=get_top_from_p(den,300.0,0.1,1e27,1,dos_all);
	beta_muh=in->beta*get_p_mu(offset,300.0,0.1,1,in->adv_sim)/2.0;

	double langevin=q*(alpha_mue+beta_muh)/(3.8*epsilon0);
	fprintf (file_rbi,"%e %e %e %e\n",den,langevin,q*alpha_mue/(3.8*epsilon0),q*beta_muh/(3.8*epsilon0));
	den*=1.2;
	}while(den<5e23);

	fclose(file_rbi);
*/
}

void tau_test(struct device *in)
{

}

/*FILE *out;
out=fopen("./rbiplot.dat","w");
double n=1e21;
double mu_min=0.0;
double Rbi_mul;
double langevin;
double Tlc=300.0;
double epc=in->epsilonr[0]*epsilon0;
do
{
		fprintf(out,"%le ",n);
		mu_min=in->mun[0];
		if (mu_min>in->mup[0]) mu_min=in->mup[0];
		langevin=q*(mu_min)/(epc);
		Rbi_mul=1.0;
		fprintf(out,"%le ",Rbi_mul*langevin);

		mu_min=(in->mup[0]+in->mun[0])/2.0;
		langevin=q*(mu_min)/(epc);
		Rbi_mul=1.0;
		fprintf(out,"%le ",Rbi_mul*langevin);

		mu_min=(in->mup[0]+in->mun[0])/2.0;
		langevin=q*(mu_min)/(epc);
		//printf("%e\n",langevin);
		double rc=q*q/(4.0*pi*epsilon0*in->epsilonr[0]*kb*Tlc);
		double A=in->A[0];
		double deltaE=in->deltaE[0];
		//printf("%e %e\nls
",deltaE,A);
		double R=in->a[0];
		double Dp=A*exp(-(deltaE*q/(kb*Tlc)));
		Rbi_mul=1.0/(1-exp(-rc/R)+(Dp*rc/R/R)*exp(-rc/R));
		//printf("%e %e\n",q*(mu_min)*exp(-q*0.178/(kb*Tlc))/(epc),Rbi_mul*langevin);
		fprintf(out,"%le ",Rbi_mul*langevin);


		Rbi_mul=1.0;
		mu_min=(in->mup[0]+in->mun[0])/2.0;
		langevin=q*(mu_min)*exp(-q*0.178/(kb*Tlc))/(epc);
		fprintf(out,"%le ",Rbi_mul*langevin);


		Rbi_mul=1.0;
		langevin=get_mat_param_xy(&(in->mat.l[in->imat[0]]),mat_rbi,n);
		//printf("Here I am %e\n",langevin);
		if (langevin<0) langevin=1e-30;
		fprintf(out,"%le ",Rbi_mul*langevin);

		//printf("Calculating with this\n");
		Rbi_mul=1.0;
		//printf("%e\n",deibel);
		langevin=q*2.0*sqrt(in->mup[0]*in->mun[0])/epc;
		fprintf(out,"%le ",Rbi_mul*langevin);
		fprintf(out,"\n");

n*=1.1;
}
while (n<1e24);
fclose(out);
*/

